package cz.iivos.pjj.weather;

import java.rmi.AccessException;
import java.rmi.NotBoundException;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

public class RegistryObserver {

    /**
     * @param args
     */
    public static void main(String[] args) {
        Registry registry;
        try {
            registry = LocateRegistry.getRegistry();
        } catch (RemoteException e) {
            System.err.println("RMI registry neběží na tomto počítači.");
            e.printStackTrace();
            return;
        }

        for (;;) {
            System.out.println();
            System.out.println("Zaregistrované servery:");
            try {
                String[] names = registry.list();
                System.out.println("Počet: " + names.length);
                for (String s : names) {
                    Remote remote = registry.lookup(s);
                    System.out.println(s + ":\t" + remote.toString());
                }
            } catch (AccessException e) {
                System.err.println("Chyba přístupu k RMI registry.");
                e.printStackTrace();
                return;
            } catch (RemoteException e) {
                System.err.println("Chyba při práci s RMI registry.");
                e.printStackTrace();
                return;
            } catch (NotBoundException e) {
                // objekt se odregistroval mezi voláním metod
                // co se dá dělat...
            }
            try {
                Thread.sleep(5000);
            } catch (InterruptedException e) {
            }
        }


    }
}
